package sys

import (
	"syscall"
)

// SetLimit set NOFILE
func SetLimit(uint64 max) error {
	var rlimit syscall.Rlimit

	err := syscall.Getrlimit(syscall.RLIMIT_NOFILE, &rlimit)
	if err != nil {
		return err
	}

	rlimit.Cur = max
	rlimit.Max = max
	err = syscall.Setrlimit(syscall.RLIMIT_NOFILE, &rlimit)
	if err != nil {
		return err
	}

	return nil
}
